function SimpleMp3Counter_OnLoad(self)
    this.TimeSinceLastUpdate = 0;
    this.TimeSinceLastScrollUpdate = 0;
    allEvents = false
    if (allEvents == true) then
        this:RegisterAllEvents();
    end
    this:RegisterEvent("ADDON_LOADED")
    this:RegisterEvent("PLAYER_LEAVING_WORLD");
    this:RegisterEvent("PLAYER_DEAD");
    this:RegisterEvent("PLAYER_ENTERING_WORLD");
    this:RegisterEvent("PLAYER_ALIVE");
    this:RegisterEvent("CINEMATIC_START");
    this:RegisterEvent("CINEMATIC_STOP");
    --[[this:RegisterEvent("GOSSIP_SHOW");
    this:RegisterEvent("GOSSIP_CLOSED");
    this:RegisterEvent("TRAINER_SHOW");
    this:RegisterEvent("TRAINER_CLOSED");
    this:RegisterEvent("MERCHANT_SHOW");
    this:RegisterEvent("MERCHANT_CLOSED");]]

    -- Voice Chat events
    this:RegisterEvent("VOICE_START");
    this:RegisterEvent("VOICE_STOP");
    this:RegisterEvent("VOICE_PUSH_TO_TALK_START");
    this:RegisterEvent("VOICE_PUSH_TO_TALK_STOP");
    this.VoiceChat = 0;
    SlashCmdList["SIMPLEMP3COMMAND"] = SimpleMp3_SlashCommands;
    SLASH_SIMPLEMP3COMMAND1 = "/smp3";
end

function SimpleMp3Counter_OnUpdate(ElapsedTime)
    if (Smp3_Save.wasVisibleMain) then
        SimpleMp3Form:Show();
    end
    if (Smp3_Save.wasVisibleVolume) then
        SimpleMp3VolumeForm:Show();
    end
    if (Smp3_Save.wasVisibleLIB) then
        SimpleMp3LibraryForm:Show();
    end
    if (Smp3_Save.wasVisiblePL) then
        SimpleMp3PlaylistForm:Show();
    end
    this.TimeSinceLastUpdate = this.TimeSinceLastUpdate + ElapsedTime;
    this.TimeSinceLastScrollUpdate = this.TimeSinceLastScrollUpdate + ElapsedTime;


    while (this.TimeSinceLastScrollUpdate > SimpleMp3_ScrollUpdate) do
        if (isScrolling == true) then
            ScrollNameLabel();
        end
        this.TimeSinceLastScrollUpdate = this.TimeSinceLastScrollUpdate - SimpleMp3_ScrollUpdate;
    end

    while (this.TimeSinceLastUpdate > SimpleMp3_UpdateInterval) do

        if (isPlaying == false) then
            if (Smp3_Save.wasPlaying == true) then
                if (playDelay >= 1) then
                    Sec = playDelay;
                    Sec2 = playDelay;
                    playDelay = (playDelay - 1)
                elseif (playDelay == 0) then
                    Smp3_Save.wasPlaying = false
                    if (Smp3_Save.nextTrack == true) then
                        SimpleMp3_NextClick();
                    end
                    Smp3_Length = SimpleMp3PlaylistForm_Info('length', Smp3_Save.Current);
                    SimpleMp3Form_StartMusic(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, true);
                end
            end
        end

        if (Hr2 <= 9) then
            if (Min2 <= 9) then
                if (Sec2 <= 9) then
                    SetTimeLabel("0" .. Hr2 .. ":0" .. Min2 .. ":0" .. Sec2);

                elseif (Sec2 >= 10) then
                    SetTimeLabel ("0" .. Hr2 .. ":0" .. Min2 .. ":" .. Sec2);
                end
            elseif (Min2 >= 10) then
                if (Sec2 <= 9) then
                    SetTimeLabel("0" .. Hr2 .. ":" .. Min2 .. ":0" .. Sec2);

                elseif (Sec2 >= 10) then
                    SetTimeLabel ("0" .. Hr2 .. ":" .. Min2 .. ":" .. Sec2);
                end
            end
        elseif (Hr2 >= 10) then
            if (Min2 <= 9) then
                if (Sec2 <= 9) then
                    SetTimeLabel(Hr2 .. ":0" .. Min2 .. ":0" .. Sec2);

                elseif (Sec2 >= 10) then
                    SetTimeLabel (Hr2 .. ":0" .. Min2 .. ":" .. Sec2);
                end
            elseif (Min2 >= 10) then
                if (Sec2 <= 9) then
                    SetTimeLabel(Hr2 .. ":" .. Min2 .. ":0" .. Sec2);

                elseif (Sec2 >= 10) then
                    SetTimeLabel (Hr2 .. ":" .. Min2 .. ":" .. Sec2);
                end
            end
        end
        if (Hr <= 9) then
            if (Min <= 9) then
                if (Sec <= 9) then
                    SetTimeLabel2("0" .. Hr .. ":0" .. Min .. ":0" .. Sec);

                elseif (Sec >= 10) then
                    SetTimeLabel2 ("0" .. Hr .. ":0" .. Min .. ":" .. Sec);
                end
            elseif (Min >= 10) then
                if (Sec <= 9) then
                    SetTimeLabel2("0" .. Hr .. ":" .. Min .. ":0" .. Sec);

                elseif (Sec >= 10) then
                    SetTimeLabel2 ("0" .. Hr .. ":" .. Min .. ":" .. Sec);
                end
            end
        elseif (Hr >= 10) then
            if (Min <= 9) then
                if (Sec <= 9) then
                    SetTimeLabel2(Hr .. ":0" .. Min .. ":0" .. Sec);

                elseif (Sec >= 10) then
                    SetTimeLabel2 (Hr .. ":0" .. Min .. ":" .. Sec);
                end
            elseif (Min >= 10) then
                if (Sec <= 9) then
                    SetTimeLabel2(Hr .. ":" .. Min .. ":0" .. Sec);

                elseif (Sec >= 10) then
                    SetTimeLabel2 (Hr .. ":" .. Min .. ":" .. Sec);
                end
            end
        end

        if (isPlaying) or (isPlayingDemo) then
            if (Sec == 59) then
                Min = Min + 1;
                Sec = -1;
            end

            if (Min == 59) then
                Hr = Hr + 1;
                Min = 0;
                Sec = -1;
            end

            if (Min2 > 0) then
                if (Sec2 == 0) then
                    Min2 = Min2 - 1;
                    Sec2 = 60;
                end
            end

            if (Hr2 > 0) then
                if (Min2 == 0) then
                    Hr2 = Hr2 - 1;
                    Min2 = 60;
                    Sec2 = 60;
                end
            end

            Sec = Sec + 1;
            Sec2 = Sec2 - 1;
            TotalSecs = ((Hr * 60) + (Min * 60) + Sec);

            if (isPlaying == true) then
                if(TotalSecs == Smp3_Length) then
                    SimpleMp3_NextClick();
                end
            elseif (isPlayingDemo == true) then
                if(TotalSecs == Smp3_Length) then
                    SimpleMp3Form_StopMusic();
                    isPlayingDemo = false
                    return
                elseif(TotalSecs == demoLimit) then
                    SimpleMp3Form_StopMusic();
                    isPlayingDemo = false
                    return
                end
            end
        end
        this.TimeSinceLastUpdate = this.TimeSinceLastUpdate - SimpleMp3_UpdateInterval;
    end
end

function SimpleMp3Counter_OnEvent()
    if (allEvents == true) then
        SimpleMp3_Output(event, "debug");
    end
    if (event == "ADDON_LOADED") then
        if (arg1 == 'SimpleMp3') then
            SimpleMp3_Addon_Loaded = true;
            hooksecurefunc("ReloadUI", SimpleMp3_ReloadUI);
            hooksecurefunc("Logout", SimpleMp3_Logout);
            SavedVariablesUpdate();
            SetCVar("Sound_MusicVolume", 1-Smp3_Save.Volume);
            if (Smp3_Save.PlayListVersion ~= SimpleMp3_PL_VERSION) then
                SimpleMp3_Output(SIMPLEMP3_NEW_PL, "debug");
                Smp3_Save.PlayListVersion = SimpleMp3_PL_VERSION;
            end
            SimpleMp3Form_ResetDisplay(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, true);
            tsort(SimpleMp3Library, Smp3_Save.sortFieldLIB, Smp3_Save.sortOrderLIB)
            if (Smp3_Save.playOnStart == true) then
                Smp3_Save.wasPlaying = true;
                playDelay = Smp3_Save.playDelay;
            end
            if (Smp3_Save.changeVolumeInVC == false) then
                this:UnregisterEvent("VOICE_START");
                this:UnregisterEvent("VOICE_STOP");
                this:UnregisterEvent("VOICE_PUSH_TO_TALK_START");
                this:UnregisterEvent("VOICE_PUSH_TO_TALK_STOP");
                this.VoiceChat = 0;
            end
            SimpleMp3_Output("Saved Volume is "..Smp3_Save.Volume, "debug");
            this:UnregisterEvent("ADDON_LOADED")
        end
    elseif (event == "PLAYER_LEAVING_WORLD") or (event == "PLAYER_DEAD") or (event == "CINEMATIC_START") then
        if (isPlaying == true) then
            SimpleMp3Form_StopMusic();
            Smp3_Save.wasPlaying = true;
        end
    elseif (event == "PLAYER_ENTERING_WORLD") or (event == "PLAYER_ALIVE") or (event == "CINEMATIC_STOP") then
        SetCVar("Sound_EnableMusic", Smp3_Save.MuteOnStop);
        SimpleMp3Form_ResetDisplay(SimpleMp3PlaylistForm_Info('name', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('song', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('artist', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('album', Smp3_Save.Current), SimpleMp3PlaylistForm_Info('length2', Smp3_Save.Current), Smp3_Save.Current, true);
        if (Smp3_Save.wasPlaying == true) then
            playDelay = Smp3_Save.playDelay;
        end
        isPlaying = false;
    elseif (event == "VOICE_START") or (event == "VOICE_PUSH_TO_TALK_START") --[[or (event == "GOSSIP_SHOW") or (event == "TRAINER_SHOW") or (event == "MERCHANT_SHOW")]] then
        if (this.VoiceChat == 0) then
            this.VoiceChat = 1;
            SetCVar("Sound_MusicVolume", 0.1);
        end
    elseif (event == "VOICE_STOP") or (event == "VOICE_PUSH_TO_TALK_STOP") --[[or (event == "GOSSIP_CLOSED") or (event == "TRAINER_CLOSED") or (event == "MERCHANT_CLOSED")]] then
        if (this.VoiceChat == 1) then
            this.VoiceChat = 0;
            SetCVar("Sound_MusicVolume", (1 - Smp3_Save.Volume));
        end
    end
    collectgarbage();
end
