function SimpleMp3OptionsGeneralShow()
    getglobal(this:GetName().."CheckSounds"):SetChecked(Smp3_Save.PlaySounds);
    getglobal(this:GetName().."CheckMute"):SetChecked(Smp3_Save.MuteOnStop);
    getglobal(this:GetName().."CheckTags"):SetChecked(Smp3_Save.UseTags);
    getglobal(this:GetName().."CheckPlayOnStart"):SetChecked(Smp3_Save.playOnStart);
    getglobal(this:GetName().."CheckNextTrack"):SetChecked(Smp3_Save.nextTrack);
    getglobal(this:GetName().."CheckVCVolumeControl"):SetChecked(Smp3_Save.changeVolumeInVC);
    getglobal(this:GetName().."CheckShowOutput"):SetChecked(Smp3_Save.showOutput);
    getglobal(this:GetName().."CheckShowDebug"):SetChecked(Smp3_Save.showDebug);
    getglobal(this:GetName().."SliderValueLabel"):SetText(Smp3_Save.playDelay);
    UIDropDownMenu_SetSelectedValue(getglobal(this:GetName().."DropDownMenuList"), Smp3_Save.sortList);
    UIDropDownMenu_SetText(getglobal(this:GetName().."DropDownMenuList"), SIMPLEMP3_SORTLIST);
    if (Smp3_Save.sortList == 1) then
        UIDropDownMenu_SetSelectedValue(getglobal(this:GetName().."DropDownMenuOrder"), Smp3_Save.sortOrderPL);
        UIDropDownMenu_SetText(getglobal(this:GetName().."DropDownMenuOrder"), SIMPLEMP3_SORTORDER);
    elseif (Smp3_Save.sortList == 2) then
        UIDropDownMenu_SetSelectedValue(getglobal(this:GetName().."DropDownMenuOrder"), Smp3_Save.sortOrderLIB);
        UIDropDownMenu_SetText(getglobal(this:GetName().."DropDownMenuOrder"), SIMPLEMP3_SORTORDER);
    end
    if (Smp3_Save.sortList == 1) then
        UIDropDownMenu_SetSelectedValue(getglobal(this:GetName().."DropDownMenuField"), Smp3_Save.sortFieldPL);
        UIDropDownMenu_SetText(getglobal(this:GetName().."DropDownMenuField"), SIMPLEMP3_SORTFIELD);
    elseif (Smp3_Save.sortList == 2) then
        UIDropDownMenu_SetSelectedValue(getglobal(this:GetName().."DropDownMenuField"), Smp3_Save.sortFieldLIB);
        UIDropDownMenu_SetText(getglobal(this:GetName().."DropDownMenuField"), SIMPLEMP3_SORTFIELD);
    end
end

function SliderPlayOnStart_OnValueChanged(value)
    if (getglobal(this:GetParent():GetName().."SliderValueLabel") ~= nil) then
        getglobal(this:GetParent():GetName().."SliderValueLabel"):SetText(value);
    end
end
function SimpleMp3SoundsClick()
    if (Smp3_Save.PlaySounds == true) then
        Smp3_Save.PlaySounds = false;
        PlaySound("igMainMenuOptionCheckBoxOff");
    else
        Smp3_Save.PlaySounds = true;
        PlaySound("igMainMenuOptionCheckBoxOn");
    end
end

function SimpleMp3MuteClick()
    if (Smp3_Save.MuteOnStop == 0) then
        Smp3_Save.MuteOnStop = 1;
        PlaySound("igMainMenuOptionCheckBoxOn");
    else
        Smp3_Save.MuteOnStop = 0;
        PlaySound("igMainMenuOptionCheckBoxOff");
    end
    if not (isPlaying) then
        SetCVar("Sound_EnableMusic", Smp3_Save.MuteOnStop);
    end
end

function SimpleMp3TagsClick()
    if (Smp3_Save.UseTags == true) then
        Smp3_Save.UseTags = false;
        PlaySound("igMainMenuOptionCheckBoxOff");
    else
        Smp3_Save.UseTags = true;
        PlaySound("igMainMenuOptionCheckBoxOn");
    end
end

function SimpleMp3PlayOnStartClick()
    if (Smp3_Save.playOnStart == true) then
        Smp3_Save.playOnStart = false;
        PlaySound("igMainMenuOptionCheckBoxOff");
    else
        Smp3_Save.playOnStart = true;
        PlaySound("igMainMenuOptionCheckBoxOn");
    end
end

function SimpleMp3NextTrackClick()
    if (Smp3_Save.nextTrack == true) then
        Smp3_Save.nextTrack = false;
        PlaySound("igMainMenuOptionCheckBoxOff");
    else
        Smp3_Save.nextTrack = true;
        PlaySound("igMainMenuOptionCheckBoxOn");
    end
end

function SimpleMp3SetOutputClick()
    if (Smp3_Save.showOutput == true) then
        Smp3_Save.showOutput = false;
        SetHideShowOutputBnText(SIMPLEMP3_SHOWOUTPUT_BN);
        PlaySound("igMainMenuOptionCheckBoxOff");
    else
        Smp3_Save.showOutput = true;
        SetHideShowOutputBnText(SIMPLEMP3_HIDEOUTPUT_BN);
        PlaySound("igMainMenuOptionCheckBoxOn");
    end
end

function SimpleMp3SetDebugClick()
    if (Smp3_Save.showDebug == true) then
        Smp3_Save.showDebug = false;
        PlaySound("igMainMenuOptionCheckBoxOff");
    else
        Smp3_Save.showDebug = true;
        PlaySound("igMainMenuOptionCheckBoxOn");
    end
end

function SimpleMp3VCVolumeControlClick()
    if (Smp3_Save.changeVolumeInVC == true) then
        Smp3_Save.changeVolumeInVC = false;
        PlaySound("igMainMenuOptionCheckBoxOff");
    else
        Smp3_Save.changeVolumeInVC = true;
        PlaySound("igMainMenuOptionCheckBoxOn");
    end
end

function SimpleMp3SortNow()
    if (Smp3_Save.sortList == 1) then
        tsort(Smp3_Save["SimpleMp3PlayList"], Smp3_Save.sortFieldPL, Smp3_Save.sortOrderPL);
    elseif (Smp3_Save.sortList == 2) then
        tsort(SimpleMp3Library, Smp3_Save.sortFieldLIB, Smp3_Save.sortOrderLIB);
    end
end

function SetSortList()
    Smp3_Save.sortList = this.value
    UIDropDownMenu_SetSelectedValue(this.owner, this.value);
    SimpleMp3DropDownMenuOrder_Initialize();
    SimpleMp3DropDownMenuField_Initialize();
end

local infoList = { func = SetSortList };
function SimpleMp3DropDownMenuList_Initialize()
    local selectedValue = UIDropDownMenu_GetSelectedValue(getglobal(this:GetParent():GetName()));

    infoList.text = SIMPLEMP3_BINDPL_BN;
    infoList.owner = this:GetParent();
    infoList.value = 1;
    infoList.checked = infoList.value == selectedValue;
    infoList.tooltipTitle = SIMPLEMP3_BINDPL_BN;
    infoList.tooltipText = SIMPLEMP3_SORTPL_TT;
    UIDropDownMenu_AddButton(infoList);

    infoList.text = SIMPLEMP3_BINDLIB_BN;
    infoList.owner = this:GetParent();
    infoList.value = 2;
    infoList.checked = infoList.value == selectedValue;
    infoList.tooltipTitle = SIMPLEMP3_BINDLIB_BN;
    infoList.tooltipText = SIMPLEMP3_SORTLIB_TT;
    UIDropDownMenu_AddButton(infoList);

    selectedValue = ""
end

function SetSortOrder()
    if (Smp3_Save.sortList == 1) then
        Smp3_Save.sortOrderPL = this.value;
    elseif (Smp3_Save.sortList == 2) then
        Smp3_Save.sortOrderLIB = this.value;
    end
    UIDropDownMenu_SetSelectedValue(this.owner, this.value);
end

local infoOrder = { func = SetSortOrder };
function SimpleMp3DropDownMenuOrder_Initialize()
    local selectedValue = UIDropDownMenu_GetSelectedValue(getglobal(this:GetParent():GetName()));

    infoOrder.text = SIMPLEMP3_SORTASCEND;
    infoOrder.owner = this:GetParent();
    infoOrder.value = 1;
    infoOrder.checked = infoOrder.value == selectedValue;
    infoOrder.tooltipTitle = SIMPLEMP3_SORTASCEND;
    infoOrder.tooltipText = SIMPLEMP3_SORTASCEND_TT;
    UIDropDownMenu_AddButton(infoOrder);

    infoOrder.text = SIMPLEMP3_SORTDESCEND;
    infoOrder.owner = this:GetParent();
    infoOrder.value = 2;
    infoOrder.checked = infoOrder.value == selectedValue;
    infoOrder.tooltipTitle = SIMPLEMP3_SORTDESCEND;
    infoOrder.tooltipText = SIMPLEMP3_SORTASCEND_TT;
    UIDropDownMenu_AddButton(infoOrder);

    selectedValue = ""
end

function SetSortField()
    if (Smp3_Save.sortList == 1) then
        Smp3_Save.sortFieldPL = this.value;
    elseif (Smp3_Save.sortList == 2) then
        Smp3_Save.sortFieldLIB = this.value;
    end
    UIDropDownMenu_SetSelectedValue(this.owner, this.value);
end
local infoField = { func = SetSortField };
function SimpleMp3DropDownMenuField_Initialize()
    local selectedValue = UIDropDownMenu_GetSelectedValue(getglobal(this:GetParent():GetName()));

    infoField.text = SIMPLEMP3_SORTNAME;
    infoField.owner = this:GetParent();
    infoField.value = 1;
    infoField.checked = infoField.value == selectedValue;
    infoField.tooltipTitle = SIMPLEMP3_SORTNAME;
    infoField.tooltipText = SIMPLEMP3_SORTNAME_TT;
    UIDropDownMenu_AddButton(infoField);

    infoField.text = SIMPLEMP3_SORTTITLE;
    infoField.owner = this:GetParent();
    infoField.value = 2;
    infoField.checked = infoField.value == selectedValue;
    infoField.tooltipTitle = SIMPLEMP3_SORTTITLE;
    infoField.tooltipText = SIMPLEMP3_SORTTITLE_TT;
    UIDropDownMenu_AddButton(infoField);

    infoField.text = SIMPLEMP3_SORTARTIST;
    infoField.owner = this:GetParent();
    infoField.value = 3;
    infoField.checked = infoField.value == selectedValue;
    infoField.tooltipTitle = SIMPLEMP3_SORTARTIST;
    infoField.tooltipText = SIMPLEMP3_SORTARTIST_TT;
    UIDropDownMenu_AddButton(infoField);

    infoField.text = SIMPLEMP3_SORTALBUM;
    infoField.owner = this:GetParent();
    infoField.value = 4;
    infoField.checked = infoField.value == selectedValue;
    infoField.tooltipTitle = SIMPLEMP3_SORTALBUM;
    infoField.tooltipText = SIMPLEMP3_SORTALBUM_TT;
    UIDropDownMenu_AddButton(infoField);

    infoField.text = SIMPLEMP3_SORTGENRE;
    infoField.owner = this:GetParent();
    infoField.value = 5;
    infoField.checked = infoField.value == selectedValue;
    infoField.tooltipTitle = SIMPLEMP3_SORTGENRE;
    infoField.tooltipText = SIMPLEMP3_SORTGENRE_TT;
    UIDropDownMenu_AddButton(infoField);

    infoField.text = SIMPLEMP3_SORTLENGTH;
    infoField.owner = this:GetParent();
    infoField.value = 6;
    infoField.checked = infoField.value == selectedValue;
    infoField.tooltipTitle = SIMPLEMP3_SORTLENGTH;
    infoField.tooltipText = SIMPLEMP3_SORTLENGTH_TT;
    UIDropDownMenu_AddButton(infoField);

    infoField.text = SIMPLEMP3_SORTBITRATE;
    infoField.owner = this:GetParent();
    infoField.value = 7;
    infoField.checked = infoField.value == selectedValue;
    infoField.tooltipTitle = SIMPLEMP3_SORTBITRATE;
    infoField.tooltipText = SIMPLEMP3_SORTBITRATE_TT;
    UIDropDownMenu_AddButton(infoField);

    selectedValue = "";
end
