------------------------------------------------------
-- Slash command handler
------------------------------------------------------
function SimpleMp3_SlashCommands(cmd)
    local command = string.lower(cmd);
    if (command == "") then
        SimpleMp3_Output(SIMPLEMP3_SLASHCOMMAND.. SIMPLEMP3_SLASHCOMLIST, "error");
    elseif (command == "icon") then
        if (SimpleMp3MiniMapButton:IsVisible()) then
            SimpleMp3MiniMapButton:Hide();
        else
            SimpleMp3MiniMapButton:Show();
        end
    elseif (command == "volume") then
        if (SimpleMp3VolumeForm:IsVisible()) then
            SimpleMp3VolumeForm:Hide();
        else
            SimpleMp3VolumeForm:Show();
        end
    elseif (command == "player") then
        if (SimpleMp3Form:IsVisible()) then
                SimpleMp3Form:Hide();
        else
            SimpleMp3Form:Show();
        end
    elseif (command == "playlist") then
        if (SimpleMp3PlaylistForm:IsVisible()) then
                SimpleMp3PlaylistForm:Hide();
        else
            SimpleMp3PlaylistForm:Show();
        end
    elseif (command == "library") then
        if (SimpleMp3LibraryForm:IsVisible()) then
                SimpleMp3LibraryForm:Hide();
        else
            SimpleMp3LibraryForm:Show();
        end
    elseif (command == "play") then
        SimpleMp3_PlayStopClick();
    elseif (command == "stop") then
        SimpleMp3_PlayStopClick();
    elseif (command == "next") then
        SimpleMp3_NextClick();
    elseif (command == "prev") then
        SimpleMp3_PrevClick();
    end
end
