function Player_Volumeview()
    if (MouseButton == 'RightButton') then
        if (SimpleMp3VolumeForm:IsVisible()) then
            SimpleMp3VolumeForm:Hide();
        else
            SimpleMp3VolumeForm:Show();
        end
    end
end

function SimpleMp3Volume_OnShow()
    if (Smp3_Save.PlaySounds == true) then
        PlaySound("igCharacterInfoOpen");
    end
    Smp3_Save.wasVisibleVolume = true;
end

function SimpleMp3Volume_OnHide()
    if (Smp3_Save.PlaySounds == true) then
        PlaySound("igCharacterInfoClose");
    end
    Smp3_Save.wasVisibleVolume = false;
end

-- The mousewheel volume function
function SimpleMp3Volume_OnMouseWheel(Direction)
    local SliderVar;
    SliderVar = getglobal("SimpleMp3VolumeForm" .. "Slider");
    local var = SliderVar:GetValue();
    if (Direction == 1) then
        if (var > 0) then
            var = var - 0.1;
        end
    else
        if (var < 1) then
            var = var + 0.1;
        end
    end
    Smp3_Save.Volume = var;
    SimpleMp3_Output("Volume is "..var.." Saved Volume is "..Smp3_Save.Volume.." Volume is "..tonumber(GetCVar("Sound_MusicVolume")), "debug");
end

function SimpleMp3Volume_OnValueChanged()
    if (SimpleMp3_Addon_Loaded == true) then
        this:SetValue(Smp3_Save.Volume);
        SetCVar("Sound_MusicVolume", 1-this:GetValue());
    end
end
